Index: /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/HeuristicLab.Clients.Hive.Slave.ConsoleClient-3.3.csproj
===================================================================
--- /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/HeuristicLab.Clients.Hive.Slave.ConsoleClient-3.3.csproj	(revision 15659)
+++ /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/HeuristicLab.Clients.Hive.Slave.ConsoleClient-3.3.csproj	(revision 15660)
@@ -103,4 +103,7 @@
     <Compile Include="Program.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="Properties\AssemblyInfo.cs.frame" />
     <Compile Include="SlaveCommListener.cs" />
@@ -112,9 +115,4 @@
       <Private>True</Private>
     </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="app.config">
-      <SubType>Designer</SubType>
-    </None>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
@@ -133,4 +131,29 @@
 </PreBuildEvent>
   </PropertyGroup>
+  <PropertyGroup>
+    <PostBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">
+set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set OutDir=$(OutDir)
+set TargetDir=$(TargetDir)
+set TargetPath=$(TargetPath)
+set Platform=$(PlatformName)
+set Configuration=$(ConfigurationName)
+
+call "$(SolutionDir)MergeConfigs.cmd"
+    </PostBuildEvent>
+    <PostBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+export ProjectDir=$(ProjectDir)
+export SolutionDir=$(SolutionDir)
+export OutDir=$(OutDir)
+export TargetDir=$(TargetDir)
+export TargetPath=$(TargetPath)
+export Platform=$(PlatformName)
+export Configuration=$(ConfigurationName)
+
+$SolutionDir/MergeConfigs.sh
+</PostBuildEvent>
+  </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
        Other similar extension points exist, see Microsoft.Common.targets.
Index: /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config
===================================================================
--- /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 15659)
+++ /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 15660)
@@ -2,114 +2,11 @@
 <configuration>
   <configSections>
-    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-      <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false"/>
-      <section name="HeuristicLab.Clients.Hive.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false"/>
-    </sectionGroup>
   </configSections>
 
-  <userSettings>
-    <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
-      <setting name="LastUsedFileName" serializeAs="String">
-        <value>lastUsed.dat</value>
-      </setting>
-      <setting name="PluginCacheDir" serializeAs="String">
-        <value>PluginCache</value>
-      </setting>
-      <setting name="PluginTempBaseDir" serializeAs="String">
-        <value>PluginTemp</value>
-      </setting>
-      <setting name="ConfigurationName" serializeAs="String">
-        <value>Configuration</value>
-      </setting>
-      <setting name="PluginInfrastructureDll" serializeAs="String">
-        <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
-      </setting>
-      <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</value>
-      </setting>
-      <setting name="ClientsHiveDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive-3.3.dll</value>
-      </setting>
-      <setting name="HiveDll" serializeAs="String">
-        <value>HeuristicLab.Hive-3.3.dll</value>
-      </setting>
-      <setting name="ClientsCommonDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Common-3.3.dll</value>
-      </setting>
-      <setting name="PluginLifetime" serializeAs="String">
-        <value>3</value>
-      </setting>
-      <setting name="DirOpSleepTime" serializeAs="String">
-        <value>00:00:01</value>
-      </setting>
-      <setting name="PluginDeletionRetries" serializeAs="String">
-        <value>5</value>
-      </setting>
-      <setting name="PluginDeletionTimeout" serializeAs="String">
-        <value>00:00:01</value>
-      </setting>
-      <setting name="ExecutorSemTimeouts" serializeAs="String">
-        <value>00:00:46</value>
-      </setting>
-      <setting name="QueuesMaxThreads" serializeAs="String">
-        <value>5000</value>
-      </setting>
-      <setting name="SlaveCommunicationServiceEndpoint" serializeAs="String">
-        <value>SlaveCommunicationServiceEndpoint</value>
-      </setting>
-      <setting name="SlaveUser" serializeAs="String">
-        <value>hiveslave</value>
-      </setting>
-      <setting name="SlavePwd" serializeAs="String">
-        <value>hiveslave</value>
-      </setting>
-      <setting name="MaxLogCount" serializeAs="String">
-        <value>1</value>
-      </setting>
-      <setting name="ExecutorQueueTimeout" serializeAs="String">
-        <value>00:00:20</value>
-      </setting>
-      <setting name="NrOfCoresToScavenge" serializeAs="String">
-        <value>-1</value>
-      </setting>
-      <setting name="ShutdownCommand" serializeAs="String">
-        <value>shutdown.exe</value>
-      </setting>
-      <setting name="HeartbeatInterval" serializeAs="String">
-        <value>00:00:40</value>
-      </setting>
-    </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
-    <HeuristicLab.Clients.Hive.Settings>
-      <setting name="MaxParallelUploads" serializeAs="String">
-        <value>2</value>
-      </setting>
-      <setting name="HLBinaryName" serializeAs="String">
-        <value>HeuristicLab 3.3.exe</value>
-      </setting>
-      <setting name="ResultPollingInterval" serializeAs="String">
-        <value>00:00:20</value>
-      </setting>
-      <setting name="MaxParallelDownloads" serializeAs="String">
-        <value>2</value>
-      </setting>
-      <setting name="MaxRepeatServiceCalls" serializeAs="String">
-        <value>5</value>
-      </setting>
-      <setting name="AnonymousUserName" serializeAs="String">
-        <value>anonymous</value>
-      </setting>
-      <setting name="EndpointConfigurationPriorities" serializeAs="Xml">
-        <value>
-          <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
-            <string>NetBinding_IHiveService</string>
-            <string>WSHttpBinding_IHiveService</string>
-          </ArrayOfString>
-        </value>
-      </setting>
-      <setting name="MaxEndpointRetries" serializeAs="String">
-        <value>3</value>
-      </setting>
-    </HeuristicLab.Clients.Hive.Settings>
-  </userSettings>
+  <connectionStrings>
+  </connectionStrings>
+
+  <system.serviceModel>
+  </system.serviceModel>
 
   <runtime>
Index: /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/HeuristicLab.Clients.Hive.Slave.WindowsService-3.3.csproj
===================================================================
--- /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/HeuristicLab.Clients.Hive.Slave.WindowsService-3.3.csproj	(revision 15659)
+++ /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/HeuristicLab.Clients.Hive.Slave.WindowsService-3.3.csproj	(revision 15660)
@@ -185,4 +185,29 @@
 </PreBuildEvent>
   </PropertyGroup>
+  <PropertyGroup>
+    <PostBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">
+set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set OutDir=$(OutDir)
+set TargetDir=$(TargetDir)
+set TargetPath=$(TargetPath)
+set Platform=$(PlatformName)
+set Configuration=$(ConfigurationName)
+
+call "$(SolutionDir)MergeConfigs.cmd"
+    </PostBuildEvent>
+    <PostBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+export ProjectDir=$(ProjectDir)
+export SolutionDir=$(SolutionDir)
+export OutDir=$(OutDir)
+export TargetDir=$(TargetDir)
+export TargetPath=$(TargetPath)
+export Platform=$(PlatformName)
+export Configuration=$(ConfigurationName)
+
+$SolutionDir/MergeConfigs.sh
+</PostBuildEvent>
+  </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
        Other similar extension points exist, see Microsoft.Common.targets.
Index: /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config
===================================================================
--- /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 15659)
+++ /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 15660)
@@ -2,167 +2,7 @@
 <configuration>
   <configSections>
-    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-      <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false"/>
-      <section name="HeuristicLab.Clients.Hive.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false"/>
-    </sectionGroup>
   </configSections>
 
-  <userSettings>
-    <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
-      <setting name="LastUsedFileName" serializeAs="String">
-        <value>lastUsed.dat</value>
-      </setting>
-      <setting name="PluginCacheDir" serializeAs="String">
-        <value>PluginCache</value>
-      </setting>
-      <setting name="PluginTempBaseDir" serializeAs="String">
-        <value>PluginTemp</value>
-      </setting>
-      <setting name="ConfigurationName" serializeAs="String">
-        <value>Configuration</value>
-      </setting>
-      <setting name="PluginInfrastructureDll" serializeAs="String">
-        <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
-      </setting>
-      <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</value>
-      </setting>
-      <setting name="ClientsHiveDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Hive-3.3.dll</value>
-      </setting>
-      <setting name="HiveDll" serializeAs="String">
-        <value>HeuristicLab.Hive-3.3.dll</value>
-      </setting>
-      <setting name="ClientsCommonDll" serializeAs="String">
-        <value>HeuristicLab.Clients.Common-3.3.dll</value>
-      </setting>
-      <setting name="PluginLifetime" serializeAs="String">
-        <value>3</value>
-      </setting>
-      <setting name="DirOpSleepTime" serializeAs="String">
-        <value>00:00:01</value>
-      </setting>
-      <setting name="PluginDeletionRetries" serializeAs="String">
-        <value>5</value>
-      </setting>
-      <setting name="PluginDeletionTimeout" serializeAs="String">
-        <value>00:00:01</value>
-      </setting>
-      <setting name="ExecutorSemTimeouts" serializeAs="String">
-        <value>00:00:46</value>
-      </setting>
-      <setting name="QueuesMaxThreads" serializeAs="String">
-        <value>5000</value>
-      </setting>
-      <setting name="SlaveCommunicationServiceEndpoint" serializeAs="String">
-        <value>SlaveCommunicationServiceEndpoint</value>
-      </setting>
-      <setting name="SlaveUser" serializeAs="String">
-        <value>hiveslave</value>
-      </setting>
-      <setting name="SlavePwd" serializeAs="String">
-        <value>hiveslave</value>
-      </setting>
-      <setting name="MaxLogCount" serializeAs="String">
-        <value>1</value>
-      </setting>
-      <setting name="ExecutorQueueTimeout" serializeAs="String">
-        <value>00:00:20</value>
-      </setting>
-      <setting name="NrOfCoresToScavenge" serializeAs="String">
-        <value>-1</value>
-      </setting>
-      <setting name="ShutdownCommand" serializeAs="String">
-        <value>shutdown.exe</value>
-      </setting>
-      <setting name="HeartbeatInterval" serializeAs="String">
-        <value>00:00:40</value>
-      </setting>
-      <setting name="CheckpointInterval" serializeAs="String">
-        <value>18:00:00</value>
-      </setting>
-      <setting name="CheckpointCheckInterval" serializeAs="String">
-        <value>00:05:00</value>
-      </setting>
-    </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
-    <HeuristicLab.Clients.Hive.Settings>
-      <setting name="MaxParallelUploads" serializeAs="String">
-        <value>2</value>
-      </setting>
-      <setting name="HLBinaryName" serializeAs="String">
-        <value>HeuristicLab 3.3.exe</value>
-      </setting>
-      <setting name="ResultPollingInterval" serializeAs="String">
-        <value>00:00:20</value>
-      </setting>
-      <setting name="MaxParallelDownloads" serializeAs="String">
-        <value>2</value>
-      </setting>
-      <setting name="MaxRepeatServiceCalls" serializeAs="String">
-        <value>5</value>
-      </setting>
-      <setting name="AnonymousUserName" serializeAs="String">
-        <value>anonymous</value>
-      </setting>
-      <setting name="EndpointConfigurationPriorities" serializeAs="Xml">
-        <value>
-          <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
-            <string>NetBinding_IHiveService</string>
-            <string>WSHttpBinding_IHiveService</string>
-          </ArrayOfString>
-        </value>
-      </setting>
-      <setting name="MaxEndpointRetries" serializeAs="String">
-        <value>3</value>
-      </setting>
-    </HeuristicLab.Clients.Hive.Settings>
-  </userSettings>
-
   <system.serviceModel>
-    <bindings>
-      <netTcpBinding>
-        <binding name="NetBinding_IHiveService" receiveTimeout="00:20:00"
-          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxBufferSize="2147483647"
-          maxReceivedMessageSize="2147483647">
-          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
-            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
-          <security mode="TransportWithMessageCredential">
-            <message clientCredentialType="UserName" />
-          </security>
-        </binding>
-      </netTcpBinding>
-      <wsHttpBinding>
-        <binding name="WSHttpBinding_IHiveService" receiveTimeout="00:20:00"
-          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
-          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
-            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
-          <security>
-            <message clientCredentialType="UserName" />
-          </security>
-        </binding>
-      </wsHttpBinding>
-    </bindings>
-    <services>
-      <service name="HeuristicLab.Clients.Hive.SlaveCore.SlaveCommunicationService">
-        <endpoint address="net.pipe://localhost/HeuristicLabSlaveCom" binding="netNamedPipeBinding" contract="HeuristicLab.Clients.Hive.SlaveCore.ServiceContracts.ISlaveCommunication"/>
-      </service>
-    </services>
-    <client>
-      <endpoint name="SlaveCommunicationServiceEndpoint" address="net.pipe://localhost/HeuristicLabSlaveCom" binding="netNamedPipeBinding" contract="HeuristicLab.Clients.Hive.SlaveCore.ServiceContracts.ISlaveCommunication"/>
-      <endpoint address="http://services.heuristiclab.com/Hive-3.3/HiveService.svc"
-        binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService"
-        contract="HeuristicLab.Clients.Hive.IHiveService" name="WSHttpBinding_IHiveService">
-        <identity>
-          <dns value="services.heuristiclab.com" />
-        </identity>
-      </endpoint>
-      <endpoint address="net.tcp://services.heuristiclab.com/Hive-3.3/HiveService.svc"
-        binding="netTcpBinding" bindingConfiguration="NetBinding_IHiveService"
-        contract="HeuristicLab.Clients.Hive.IHiveService" name="NetBinding_IHiveService">
-        <identity>
-          <dns value="services.heuristiclab.com" />
-        </identity>
-      </endpoint>
-    </client>
   </system.serviceModel>
 
Index: /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj
===================================================================
--- /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 15659)
+++ /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 15660)
@@ -199,23 +199,4 @@
 $SolutionDir/PreBuildEvent.sh
     </PreBuildEvent>
-    <PostBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">
-      set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
-      set ProjectDir=$(ProjectDir)
-      set SolutionDir=$(SolutionDir)
-      set OutDir=$(OutDir)
-      set TargetDir=$(TargetDir)
-      set Platform=$(PlatformName)
-      set Configuration=$(ConfigurationName)
-
-      call "$(SolutionDir)MergeConfigs.cmd"
-    </PostBuildEvent>
-    <PostBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
-export OutDir=$(OutDir)
-export ProjectDir=$(ProjectDir)
-export SolutionDir=$(SolutionDir)
-export TargetDir=$(TargetDir)
-
-$SolutionDir/MergeConfigs.sh
-    </PostBuildEvent>
   </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave/3.3/app.config
===================================================================
--- /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 15659)
+++ /branches/2877_HiveImprovements/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 15660)
@@ -4,5 +4,4 @@
     <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
       <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false"/>
-      <section name="HeuristicLab.Clients.Hive.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false"/>
     </sectionGroup>
   </configSections>
@@ -86,61 +85,7 @@
       </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
-    <HeuristicLab.Clients.Hive.Settings>
-      <setting name="MaxParallelUploads" serializeAs="String">
-        <value>2</value>
-      </setting>
-      <setting name="HLBinaryName" serializeAs="String">
-        <value>HeuristicLab 3.3.exe</value>
-      </setting>
-      <setting name="ResultPollingInterval" serializeAs="String">
-        <value>00:00:20</value>
-      </setting>
-      <setting name="MaxParallelDownloads" serializeAs="String">
-        <value>2</value>
-      </setting>
-      <setting name="MaxRepeatServiceCalls" serializeAs="String">
-        <value>5</value>
-      </setting>
-      <setting name="AnonymousUserName" serializeAs="String">
-        <value>anonymous</value>
-      </setting>
-      <setting name="EndpointConfigurationPriorities" serializeAs="Xml">
-        <value>
-          <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
-            <string>NetBinding_IHiveService</string>
-            <string>WSHttpBinding_IHiveService</string>
-          </ArrayOfString>
-        </value>
-      </setting>
-      <setting name="MaxEndpointRetries" serializeAs="String">
-        <value>3</value>
-      </setting>
-    </HeuristicLab.Clients.Hive.Settings>
   </userSettings>
 
   <system.serviceModel>
-    <bindings>
-      <netTcpBinding>
-        <binding name="NetBinding_IHiveService" receiveTimeout="00:20:00"
-          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxBufferSize="2147483647"
-          maxReceivedMessageSize="2147483647">
-          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
-            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
-          <security mode="TransportWithMessageCredential">
-            <message clientCredentialType="UserName" />
-          </security>
-        </binding>
-      </netTcpBinding>
-      <wsHttpBinding>
-        <binding name="WSHttpBinding_IHiveService" receiveTimeout="00:20:00"
-          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
-          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
-            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
-          <security>
-            <message clientCredentialType="UserName" />
-          </security>
-        </binding>
-      </wsHttpBinding>
-    </bindings>
     <services>
       <service name="HeuristicLab.Clients.Hive.SlaveCore.SlaveCommunicationService">
@@ -150,18 +95,4 @@
     <client>
       <endpoint name="SlaveCommunicationServiceEndpoint" address="net.pipe://localhost/HeuristicLabSlaveCom" binding="netNamedPipeBinding" contract="HeuristicLab.Clients.Hive.SlaveCore.ServiceContracts.ISlaveCommunication"/>
-      <endpoint address="http://services.heuristiclab.com/Hive-3.3/HiveService.svc"
-        binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService"
-        contract="HeuristicLab.Clients.Hive.IHiveService" name="WSHttpBinding_IHiveService">
-        <identity>
-          <dns value="services.heuristiclab.com" />
-        </identity>
-      </endpoint>
-      <endpoint address="net.tcp://services.heuristiclab.com/Hive-3.3/HiveService.svc"
-        binding="netTcpBinding" bindingConfiguration="NetBinding_IHiveService"
-        contract="HeuristicLab.Clients.Hive.IHiveService" name="NetBinding_IHiveService">
-        <identity>
-          <dns value="services.heuristiclab.com" />
-        </identity>
-      </endpoint>
     </client>
   </system.serviceModel>
Index: /branches/2877_HiveImprovements/HeuristicLab/3.3/HeuristicLab-3.3.csproj
===================================================================
--- /branches/2877_HiveImprovements/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 15659)
+++ /branches/2877_HiveImprovements/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 15660)
@@ -213,19 +213,23 @@
 </PreBuildEvent>
     <PostBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">
-      set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
-      set ProjectDir=$(ProjectDir)
-      set SolutionDir=$(SolutionDir)
-      set OutDir=$(OutDir)
-      set TargetDir=$(TargetDir)
-      set Platform=$(PlatformName)
-      set Configuration=$(ConfigurationName)
-
-      call "$(SolutionDir)MergeConfigs.cmd"
+set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set OutDir=$(OutDir)
+set TargetDir=$(TargetDir)
+set TargetPath=$(TargetPath)
+set Platform=$(PlatformName)
+set Configuration=$(ConfigurationName)
+
+call "$(SolutionDir)MergeConfigs.cmd"
     </PostBuildEvent>
     <PostBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
-export OutDir=$(OutDir)
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
+export OutDir=$(OutDir)
 export TargetDir=$(TargetDir)
+export TargetPath=$(TargetPath)
+export Platform=$(PlatformName)
+export Configuration=$(ConfigurationName)
 
 $SolutionDir/MergeConfigs.sh
Index: /branches/2877_HiveImprovements/MergeConfigs.cmd
===================================================================
--- /branches/2877_HiveImprovements/MergeConfigs.cmd	(revision 15659)
+++ /branches/2877_HiveImprovements/MergeConfigs.cmd	(revision 15660)
@@ -7,10 +7,10 @@
 )
 
-echo Recreating HeuristicLab 3.3.exe.config...
-copy /Y "%SolutionDir%\HeuristicLab\3.3\app.config" "%TargetDir%HeuristicLab 3.3.exe.config"
+echo Recreating %TargetPath%.config...
+copy /Y "%ProjectDir%\app.config" "%TargetPath%.config"
 
 echo Merging...
 FOR /F "tokens=*" %%A IN ('dir /B "%TargetDir%*.dll.config"') DO (
-  "%SolutionDir%ConfigMerger.exe" "%TargetDir%%%A" "%TargetDir%HeuristicLab 3.3.exe.config"
+  "%SolutionDir%ConfigMerger.exe" "%TargetDir%%%A" "%TargetPath%.config"
 )
 
Index: /branches/2877_HiveImprovements/MergeConfigs.sh
===================================================================
--- /branches/2877_HiveImprovements/MergeConfigs.sh	(revision 15659)
+++ /branches/2877_HiveImprovements/MergeConfigs.sh	(revision 15660)
@@ -3,9 +3,9 @@
 fi
 
-echo Recreating HeuristicLab 3.3.exe.config...
-cp $SolutionDir/HeuristicLab/3.3/app.config "$TargetDir/HeuristicLab 3.3.exe.config"
+echo Recreating $TargetPath.config...
+cp "$ProjectDir/app.config" "$TargetPath.config"
 
 echo Merging...
-for f in $(ls $TargetDir/*.dll.config); do 
-		mono $SolutionDir/ConfigMerger.exe $f "$TargetDir/HeuristicLab 3.3.exe.config"
+for f in $(ls "$TargetDir/*.dll.config"); do 
+		mono "$SolutionDir/ConfigMerger.exe" "$f" "$TargetPath.config"
 done